unit uSimpleSerial;

{ SimpleSerial Delhpi driver, version 0.01                      }
{ Copywrite (c) 1998 PUC-RS Virtual Reality Team                }
{ homepage at: http://www.inf.pucrs.br/~grv                     }
{ todo: make an VCL component version                           }
{       make an ActiveX component version                       }

interface

uses
  Windows, Classes, SysUtils;

type

  { TSimpleSerial type }

  TSimpleSerial = class
  private
    hPort: LongInt;
  public
    function BytesOnSerial: Integer;
    procedure SerialClear;
    function SerialRead: String;
    procedure SerialWrite(const Data: String);
    constructor Create(SerialPort: Integer);
    destructor Destroy; override;
  end;

implementation


{ TSimpleSerial implementation }

constructor TSimpleSerial.Create(SerialPort: Integer);
var
  dcbPort: TDCB;
  result:boolean;
begin
  inherited Create;
  hPort := CreateFile(PChar('COM' + IntToStr(SerialPort)), GENERIC_READ or GENERIC_WRITE, 0, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, LongInt(0));
  if hPort <> INVALID_HANDLE_VALUE then
  begin
    if GetCommState(hPort, dcbPort) then
    begin
      dcbPort.BaudRate := 9600;
      dcbPort.ByteSize := 8;
      dcbPort.Parity := NOPARITY;
      dcbPort.StopBits := ONESTOPBIT;
      dcbPort.Flags := $10;
      Result := SetCommState(hPort, dcbPort);
    end;
  end;
end;

destructor TSimpleSerial.Destroy;
Var
   result: boolean;
begin
  if hPort <> INVALID_HANDLE_VALUE then
    result := CloseHandle(hPort);
  inherited Destroy;
end;

procedure TSimpleSerial.SerialClear;
Var
   result : boolean;
begin
  if hPort <> INVALID_HANDLE_VALUE then
  begin
    result := PurgeComm(hPort, PURGE_TXABORT or PURGE_RXABORT or PURGE_TXCLEAR or PURGE_RXCLEAR);
  end;
end;

function TSimpleSerial.BytesOnSerial: Integer;
var
  statPort: TCOMSTAT;
  dwErrorCode: DWord;
begin
  if hPort <> INVALID_HANDLE_VALUE then
  begin
    ClearCommError(hPort, dwErrorCode, @statPort);
    Result := statPort.cbInQue;
  end
  else
    Result := 0;
end;

function TSimpleSerial.SerialRead: String;
var
  cbCharsAvailable, cbCharsRead: DWord;
  sBuffer: String;
begin
  cbCharsAvailable := BytesOnSerial;
  if cbCharsAvailable > 0 then
  begin
    SetLength(sBuffer, cbCharsAvailable + 1);
    ReadFile(hPort, PChar(sBuffer)^, cbCharsAvailable, cbCharsRead, nil);
    Result := Copy(sBuffer, 1, cbCharsAvailable);
  end
  else
    Result := ''
end;

procedure TSimpleSerial.SerialWrite(const Data: String);
//procedure TSimpleSerial.SerialWrite(Data: String);
var
  dwCharsWritten: DWord;
  result:boolean;
begin
  if hPort <> INVALID_HANDLE_VALUE then
    result := WriteFile(hPort, PChar(Data)^, Length(Data), dwCharsWritten, nil);
{
  if not result
  then Data := 'Erro na gravao dos Dados';
}
end;


end.
